(* fichier cazor.ml : insertion en milieu de liste *)

(* a,b,c = exposants, l=logarithme *)
type listm = {a:int; b:int; c:int; l:float; mutable tl:listm}
let ln2 = log(2.)
and ln3 = log(3.)
and ln5 = log(5.)
let rec nil={a=0; b=0; c=0; l=0.; tl=nil} (* fin de liste *)

(* insre la cellule u  la bonne place celle aprs pointe par x *)
(* et retourne le nouveau pointeur d'insertion *)
let rec insre u x =
  if u.l > x.tl.l then insre u x.tl
                  else begin 
                    x.tl <- {u with tl=x.tl};
                    x.tl
                  end

(* avance de n lments dans la liste de Hamming *)
(* x = dernier double insr, y = dernier triple, z = dernier quintuple *)
let rec avance n ({a=a; b=b; c=c; l=l} as h) x y z =
  if n=0 then h
  else begin
    let z' = {a=a; b=b; c=c+1; l=l+.ln5; tl=nil} in z.tl <- z';
    let y' = if h.c=0         then insre {h with b=b+1; l=l+.ln3} y else y in
    let x' = if h.c=0 & h.b=0 then insre {h with a=a+1; l=l+.ln2} x else x in
    avance (n-1) h.tl x' y' z'
  end

(* lance les calculs *)
let _ =
  let h = {a=0; b=0; c=0; l=0.; tl=nil} in
  let n = int_of_string(Sys.argv.(1))   in
  let t = avance n h h h h              in
  Printf.printf "2^%d . 3^%d . 5^%d" t.a t.b t.c;
  print_newline()
